【代码随想录】刷题笔记Day36

前言

  • 打球运动量不饱和,不太爽,来刷题爽爽

134. 加油站 - 力扣(LeetCode)

  • 难点在于环形遍历,实际上和最大子序和的思路很像,小于0就从下个位置开始
  • 局部最优: 当前累加resti的和curSum一旦小于0,起始位置至少要是i+1,因为从i之前开始一定不行。**全局最优:**找到可以跑一圈的起始位置
cpp 复制代码
// 暴力法:两层for,用while模拟环形
class Solution {
public:
    int canCompleteCircuit(vector<int>& gas, vector<int>& cost) {
        for (int i = 0; i < cost.size(); i++) {
            int rest = gas[i] - cost[i]; // 记录剩余油量
            int index = (i + 1) % cost.size();
            while (rest > 0 && index != i) { // 模拟以i为起点行驶一圈(如果有rest==0,那么答案就不唯一了)
                rest += gas[index] - cost[index];
                index = (index + 1) % cost.size();
            }
            // 如果以i为起点跑一圈,剩余油量>=0,返回该起始位置
            if (rest >= 0 && index == i) return i;
        }
        return -1;
    }
};
cpp 复制代码
// 贪心法,一层for
class Solution {
public:
    int canCompleteCircuit(vector<int>& gas, vector<int>& cost) {
        int curSum = 0;  // 当前汇总剩余油量
        int totalSum = 0;  // 用于看最后能否走完
        int start = 0;
        for (int i = 0; i < gas.size(); i++) {
            curSum += gas[i] - cost[i];
            totalSum += gas[i] - cost[i];
            if (curSum < 0) {   // 当前累加rest[i]和 curSum一旦小于0
                start = i + 1;  // 起始位置更新为i+1
                curSum = 0;     // curSum从0开始
            }
        }
        if (totalSum < 0) return -1; // 说明怎么走都不可能跑一圈了
        return start;  // 总和大于等于0说明能走完
    }
};

后言

  • 一道题就看了一小时了(主要是要自己想就折腾),效率还是有点低的
相关推荐
重生之小比特5 分钟前
【算法拾光】二分查找|在排序数组中查找元素的第一个和最后一个位置 + 搜索旋转排序数组
数据结构·算法·排序算法
吴可可12311 分钟前
DXF与AAMA格式转换模块推荐
算法
重生之小比特17 分钟前
【算法拾光】二分查找|搜索旋转排序数组 + 寻找旋转排序数组中的最小值
算法
YukiRinLL20 分钟前
查找与排序算法:复杂度、稳定性
数据结构·算法·排序算法
招聘风控观察8 小时前
招聘质量管理是什么?招聘质量的定义与评价口径完整解释
职场和发展
ACP广源盛139246256739 小时前
Type-C 扩展坞方案选型笔记:DP1.4 转 HDMI2.0 桥接方案评估@ACP
笔记·硬件架构·hdmi·国产芯片·扩展坞
徐小夕9 小时前
花了3个月,我们做了一款 AI 版的“飞书文档”
前端·算法·github
Robert--cao9 小时前
移动底盘与机械臂联合规划:开源算法与工程实现
算法
小豆庄10 小时前
Mac 上给视频人脸打码:本地工具的依赖、追踪与推理管线
算法·视觉检测·视频·敏捷流程·纹理贴图
星夜离尘5610 小时前
MATLAB 工程实验:从相邻块均值手写重叠 Allan 偏差,数清有效项
算法·matlab·均值算法